<?php

class onLokaRelinksContentBeforeUpdate extends cmsAction {

    public function run($item, $is_add = false){

        $ctype_name = $item['ctype_name']; // $this->request->get('ctype_name');
        $l_target = $ctype_name . '/' . $item['slug'] . '.html';
        $l_source = $ctype_name . '/' . $item['id'];
        $add_redirect = $item['loka_relinks']['add_redirect'];
        
        $uri = $item['loka_relinks']['uri'];
        if($uri){
            if(mb_strpos($uri, '/') !== 0){
                $uri = '/'.$uri;
            }
            $uri = $this->model->l_clearRoot($uri);
        }else{
            $uri = $l_target;
        }
        
        $new_target = array(
            'l_req_uri' => $uri,
            'l_type' => 'rewrite',
            'l_target' => $l_target,
            'l_source' => $l_source,
            'l_data' => array(
                'title' =>  $item['loka_relinks']['title'],
                'desc' =>  $item['loka_relinks']['desc'],
                'keys' =>  $item['loka_relinks']['keys']
            ),
            'l_template' => ''
        );
        
        unset($item['loka_relinks']);
        
        $old_target = array();
        if(!$is_add){
            $old_target = $this->model->l_getTarget('', $l_source);
        }

        if(!$old_target && $uri == $l_target && !$new_target['l_data'] && !$new_target['l_template']){
            return $item;
        }

        $redirect = array();
        $old_redirect = $this->model->l_getTarget($l_target);
        if($add_redirect && $uri != $l_target && (!$old_redirect || $old_redirect['l_target'] != $uri)){
            if($old_redirect['l_target'] != $uri){
                $this->model->l_delTarget($old_redirect['id']);
            }
            $redirect['l_req_uri'] = $l_target;
            $redirect['l_type'] = 'redirect';
            $redirect['l_target'] = $uri;
            $redirect['l_source'] = $l_source;
        }
        
        if(!$old_target){
            $this->model->l_addTarget($new_target, $redirect);
        }else{
            $this->model->l_upTarget($new_target, $old_target['id'], $redirect);
        }

        return $item;

    }

}
